/* Generated by genstub.  Do not edit. */
#include <gauche.h>
#if defined(__CYGWIN__) || defined(__MINGW32__)
#define SCM_CGEN_CONST /*empty*/
#else
#define SCM_CGEN_CONST const
#endif
#include "binary.h"

#ifdef WORDS_BIGENDIAN
#define DEFAULT_ENDIAN SCM_SYM_BIG_ENDIAN
#else
#define DEFAULT_ENDIAN SCM_SYM_LITTLE_ENDIAN
#endif

static Endian check_endian(ScmObj sym)
 {
  if (SCM_EQ(sym, SCM_SYM_BIG_ENDIAN)) return SCM_BE;
  if (SCM_EQ(sym, SCM_SYM_LITTLE_ENDIAN)) return SCM_LE;
  Scm_Error("endian must be big-endian or little-endian, but got %S", sym);
  return SCM_BE; /* dummy */
 }

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_default_endian(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_default_endian(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  SCM_ENTER_SUBR("default-endian");
  {
{
ScmObj SCM_RESULT;
 SCM_RESULT = (DEFAULT_ENDIAN);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_default_endian__NAME, "default-endian", 14, 14);
static SCM_DEFINE_SUBR(binarylib_default_endian__STUB, 0, 0, SCM_OBJ(&binarylib_default_endian__NAME), binarylib_default_endian, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_uint8(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_uint8(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-uint8");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinaryUint8(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_uint8__NAME, "read-binary-uint8", 17, 17);
static SCM_DEFINE_SUBR(binarylib_read_binary_uint8__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_uint8__NAME), binarylib_read_binary_uint8, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_uint16(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_uint16(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-uint16");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinaryUint16(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_uint16__NAME, "read-binary-uint16", 18, 18);
static SCM_DEFINE_SUBR(binarylib_read_binary_uint16__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_uint16__NAME), binarylib_read_binary_uint16, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_uint32(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_uint32(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-uint32");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinaryUint32(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_uint32__NAME, "read-binary-uint32", 18, 18);
static SCM_DEFINE_SUBR(binarylib_read_binary_uint32__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_uint32__NAME), binarylib_read_binary_uint32, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_uint64(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_uint64(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-uint64");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinaryUint64(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_uint64__NAME, "read-binary-uint64", 18, 18);
static SCM_DEFINE_SUBR(binarylib_read_binary_uint64__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_uint64__NAME), binarylib_read_binary_uint64, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_sint8(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_sint8(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-sint8");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinarySint8(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_sint8__NAME, "read-binary-sint8", 17, 17);
static SCM_DEFINE_SUBR(binarylib_read_binary_sint8__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_sint8__NAME), binarylib_read_binary_sint8, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_sint16(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_sint16(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-sint16");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinarySint16(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_sint16__NAME, "read-binary-sint16", 18, 18);
static SCM_DEFINE_SUBR(binarylib_read_binary_sint16__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_sint16__NAME), binarylib_read_binary_sint16, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_sint32(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_sint32(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-sint32");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinarySint32(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_sint32__NAME, "read-binary-sint32", 18, 18);
static SCM_DEFINE_SUBR(binarylib_read_binary_sint32__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_sint32__NAME), binarylib_read_binary_sint32, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_sint64(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_sint64(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-sint64");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinarySint64(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_sint64__NAME, "read-binary-sint64", 18, 18);
static SCM_DEFINE_SUBR(binarylib_read_binary_sint64__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_sint64__NAME), binarylib_read_binary_sint64, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_uint8(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_uint8(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-uint8");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinaryUint8(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_uint8__NAME, "write-binary-uint8", 18, 18);
static SCM_DEFINE_SUBR(binarylib_write_binary_uint8__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_uint8__NAME), binarylib_write_binary_uint8, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_uint16(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_uint16(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-uint16");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinaryUint16(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_uint16__NAME, "write-binary-uint16", 19, 19);
static SCM_DEFINE_SUBR(binarylib_write_binary_uint16__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_uint16__NAME), binarylib_write_binary_uint16, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_uint32(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_uint32(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-uint32");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinaryUint32(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_uint32__NAME, "write-binary-uint32", 19, 19);
static SCM_DEFINE_SUBR(binarylib_write_binary_uint32__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_uint32__NAME), binarylib_write_binary_uint32, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_uint64(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_uint64(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-uint64");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinaryUint64(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_uint64__NAME, "write-binary-uint64", 19, 19);
static SCM_DEFINE_SUBR(binarylib_write_binary_uint64__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_uint64__NAME), binarylib_write_binary_uint64, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_sint8(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_sint8(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-sint8");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinarySint8(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_sint8__NAME, "write-binary-sint8", 18, 18);
static SCM_DEFINE_SUBR(binarylib_write_binary_sint8__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_sint8__NAME), binarylib_write_binary_sint8, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_sint16(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_sint16(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-sint16");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinarySint16(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_sint16__NAME, "write-binary-sint16", 19, 19);
static SCM_DEFINE_SUBR(binarylib_write_binary_sint16__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_sint16__NAME), binarylib_write_binary_sint16, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_sint32(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_sint32(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-sint32");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinarySint32(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_sint32__NAME, "write-binary-sint32", 19, 19);
static SCM_DEFINE_SUBR(binarylib_write_binary_sint32__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_sint32__NAME), binarylib_write_binary_sint32, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_sint64(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_sint64(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj intval_scm;
  ScmObj intval;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-sint64");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  intval_scm = SCM_ARGREF(0);
  if (!SCM_EXACTP(intval_scm)) Scm_Error("exact integer required, but got %S", intval_scm);
  intval = (intval_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinarySint64(intval, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_sint64__NAME, "write-binary-sint64", 19, 19);
static SCM_DEFINE_SUBR(binarylib_write_binary_sint64__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_sint64__NAME), binarylib_write_binary_sint64, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_float(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_float(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-float");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinaryFloat(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_float__NAME, "read-binary-float", 17, 17);
static SCM_DEFINE_SUBR(binarylib_read_binary_float__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_float__NAME), binarylib_read_binary_float, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_read_binary_double(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_read_binary_double(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("read-binary-double");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 2 is expected, %d given.", Scm_Length(SCM_OPTARGS)+0);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
{
ScmObj SCM_RESULT;
SCM_RESULT = Scm_ReadBinaryDouble(port, endian);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_read_binary_double__NAME, "read-binary-double", 18, 18);
static SCM_DEFINE_SUBR(binarylib_read_binary_double__STUB, 0, 1, SCM_OBJ(&binarylib_read_binary_double__NAME), binarylib_read_binary_double, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_float(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_float(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj val_scm;
  ScmObj val;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-float");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  val_scm = SCM_ARGREF(0);
  if (!SCM_NUMBERP(val_scm)) Scm_Error("number required, but got %S", val_scm);
  val = (val_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinaryFloat(val, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_float__NAME, "write-binary-float", 18, 18);
static SCM_DEFINE_SUBR(binarylib_write_binary_float__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_float__NAME), binarylib_write_binary_float, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj binarylib_write_binary_double(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj binarylib_write_binary_double(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj val_scm;
  ScmObj val;
  ScmObj port_scm;
  ScmObj port;
  ScmObj endian_scm;
  Endian endian;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("write-binary-double");
  if (Scm_Length(SCM_OPTARGS) > 2)
    Scm_Error("too many arguments: up to 3 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  val_scm = SCM_ARGREF(0);
  if (!SCM_NUMBERP(val_scm)) Scm_Error("number required, but got %S", val_scm);
  val = (val_scm);
  if (SCM_NULLP(SCM_OPTARGS)) port_scm = SCM_FALSE;
  else {
    port_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  port = (port_scm);
  if (SCM_NULLP(SCM_OPTARGS)) endian_scm = DEFAULT_ENDIAN;
  else {
    endian_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  endian = check_endian(endian_scm);
  {
Scm_WriteBinaryDouble(val, port, endian);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(binarylib_write_binary_double__NAME, "write-binary-double", 19, 19);
static SCM_DEFINE_SUBR(binarylib_write_binary_double__STUB, 1, 1, SCM_OBJ(&binarylib_write_binary_double__NAME), binarylib_write_binary_double, NULL, NULL);

void Scm_Init_binarylib(ScmModule *module)
{

  SCM_DEFINE(module, "default-endian", SCM_OBJ(&binarylib_default_endian__STUB));
  SCM_DEFINE(module, "read-binary-uint8", SCM_OBJ(&binarylib_read_binary_uint8__STUB));
  SCM_DEFINE(module, "read-binary-uint16", SCM_OBJ(&binarylib_read_binary_uint16__STUB));
  SCM_DEFINE(module, "read-binary-uint32", SCM_OBJ(&binarylib_read_binary_uint32__STUB));
  SCM_DEFINE(module, "read-binary-uint64", SCM_OBJ(&binarylib_read_binary_uint64__STUB));
  SCM_DEFINE(module, "read-binary-sint8", SCM_OBJ(&binarylib_read_binary_sint8__STUB));
  SCM_DEFINE(module, "read-binary-sint16", SCM_OBJ(&binarylib_read_binary_sint16__STUB));
  SCM_DEFINE(module, "read-binary-sint32", SCM_OBJ(&binarylib_read_binary_sint32__STUB));
  SCM_DEFINE(module, "read-binary-sint64", SCM_OBJ(&binarylib_read_binary_sint64__STUB));
  SCM_DEFINE(module, "write-binary-uint8", SCM_OBJ(&binarylib_write_binary_uint8__STUB));
  SCM_DEFINE(module, "write-binary-uint16", SCM_OBJ(&binarylib_write_binary_uint16__STUB));
  SCM_DEFINE(module, "write-binary-uint32", SCM_OBJ(&binarylib_write_binary_uint32__STUB));
  SCM_DEFINE(module, "write-binary-uint64", SCM_OBJ(&binarylib_write_binary_uint64__STUB));
  SCM_DEFINE(module, "write-binary-sint8", SCM_OBJ(&binarylib_write_binary_sint8__STUB));
  SCM_DEFINE(module, "write-binary-sint16", SCM_OBJ(&binarylib_write_binary_sint16__STUB));
  SCM_DEFINE(module, "write-binary-sint32", SCM_OBJ(&binarylib_write_binary_sint32__STUB));
  SCM_DEFINE(module, "write-binary-sint64", SCM_OBJ(&binarylib_write_binary_sint64__STUB));
  SCM_DEFINE(module, "read-binary-float", SCM_OBJ(&binarylib_read_binary_float__STUB));
  SCM_DEFINE(module, "read-binary-double", SCM_OBJ(&binarylib_read_binary_double__STUB));
  SCM_DEFINE(module, "write-binary-float", SCM_OBJ(&binarylib_write_binary_float__STUB));
  SCM_DEFINE(module, "write-binary-double", SCM_OBJ(&binarylib_write_binary_double__STUB));
}
