/* Generated by genstub.  Do not edit. */
#include <gauche.h>
#if defined(__CYGWIN__) || defined(__MINGW32__)
#define SCM_CGEN_CONST /*empty*/
#else
#define SCM_CGEN_CONST const
#endif

 #include <gdbm.h>
 #include <stdlib.h>
 #include <gauche/extend.h>

 SCM_CLASS_DECL(Scm_GdbmClass);
 static void gdbm_print(ScmObj, ScmPort *, ScmWriteContext*);
 SCM_DEFINE_BUILTIN_CLASS_SIMPLE(Scm_GdbmClass, gdbm_print);

 #define SCM_CLASS_GDBM       (&Scm_GdbmClass)
 #define SCM_GDBM(obj)        ((ScmGdbm*)obj)
 #define SCM_GDBMP(obj)       SCM_XTYPEP(obj, SCM_CLASS_GDBM)

 typedef struct ScmGdbmRec {
    SCM_HEADER;
    ScmObj name;
    GDBM_FILE dbf;              /* NULL if closed */
 } ScmGdbm;

 static void gdbm_print(ScmObj obj, ScmPort *out, ScmWriteContext *ctx)
 {
    Scm_Printf(out, "#<gdbm-file %S>", SCM_GDBM(obj)->name);
 }

 #define TO_DATUM(datum_, scm_)                     \
   do {                                             \
     const ScmStringBody *b = SCM_STRING_BODY(scm_);\
     datum_.dptr = (char*)SCM_STRING_BODY_START(b); \
     datum_.dsize = SCM_STRING_BODY_SIZE(b);        \
   } while (0)
 #define FROM_DATUM(scm_, datum_)           \
   do {                                     \
     if (datum_.dptr) {                     \
       scm_ = Scm_MakeString(datum_.dptr, datum_.dsize, -1, SCM_STRING_COPYING); \
       free(datum_.dptr);                   \
     } else {                               \
       scm_ = SCM_FALSE;                    \
     }                                      \
   } while (0)

 #define CHECK_GDBM(g)    if (!g->dbf) Scm_Error("gdbm file already closed: %S", g)

 /* Those symbols may not be defined in the older gdbm */
 #ifndef GDBM_SYNC
 #define GDBM_SYNC 0
 #endif
 #ifndef GDBM_NOLOCK
 #define GDBM_NOLOCK 0
 #endif
 #ifndef GDBM_SYNCMODE
 #define GDBM_SYNCMODE 0
 #endif
 #ifndef GDBM_CENTFREE
 #define GDBM_CENTFREE 0
 #endif
 #ifndef GDBM_COALESCEBLKS
 #define GDBM_COALESCEBLKS 0
 #endif

 /* Hack for initialization stub */
 static void Scm_gdbm_internal_init(ScmModule*);
 void Scm_Init_gdbm(void)
 {
    ScmModule *mod;
    SCM_INIT_EXTENSION(gdbm);
    mod = SCM_FIND_MODULE("dbm.gdbm", SCM_FIND_MODULE_CREATE);
    Scm_InitStaticClass(&Scm_GdbmClass, "<gdbm-file>", mod, NULL, 0);
    Scm_gdbm_internal_init(mod);
 }
 #define Scm_Init_gdbm  Scm_gdbm_internal_init

static void gdbm_finalize(ScmObj obj, void *data)
 {
    ScmGdbm *g = SCM_GDBM(obj);
    if (g->dbf) { gdbm_close(g->dbf); g->dbf = NULL; }
 }

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_open(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_open(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj name_scm;
  ScmString* name;
  ScmObj size_scm;
  int size;
  ScmObj rwmode_scm;
  int rwmode;
  ScmObj fmode_scm;
  int fmode;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("gdbm-open");
  if (Scm_Length(SCM_OPTARGS) > 3)
    Scm_Error("too many arguments: up to 4 is expected, %d given.", Scm_Length(SCM_OPTARGS)+1);
  name_scm = SCM_ARGREF(0);
  if (!SCM_STRINGP(name_scm)) Scm_Error("string required, but got %S", name_scm);
  name = SCM_STRING(name_scm);
  if (SCM_NULLP(SCM_OPTARGS)) size_scm = Scm_MakeInteger(0);
  else {
    size_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  if (!SCM_INTP(size_scm)) Scm_Error("small integer required, but got %S", size_scm);
  size = SCM_INT_VALUE(size_scm);
  if (SCM_NULLP(SCM_OPTARGS)) rwmode_scm = SCM_MAKE_INT(GDBM_READER);
  else {
    rwmode_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  if (!SCM_INTP(rwmode_scm)) Scm_Error("small integer required, but got %S", rwmode_scm);
  rwmode = SCM_INT_VALUE(rwmode_scm);
  if (SCM_NULLP(SCM_OPTARGS)) fmode_scm = SCM_MAKE_INT(0666);
  else {
    fmode_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  if (!SCM_INTP(fmode_scm)) Scm_Error("small integer required, but got %S", fmode_scm);
  fmode = SCM_INT_VALUE(fmode_scm);
  {
ScmGdbm *z = SCM_NEW(ScmGdbm);
  SCM_SET_CLASS(z, SCM_CLASS_GDBM);
  Scm_RegisterFinalizer(SCM_OBJ(z), gdbm_finalize, NULL);
  z->name = SCM_OBJ(name);
  z->dbf = gdbm_open(Scm_GetString(name), size, rwmode, fmode, NULL);
  if (z->dbf == NULL) Scm_Error("couldn't open gdbm file %S (gdbm_errno=%d)", name, gdbm_errno);
  SCM_RETURN(SCM_OBJ(z));
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_open__NAME, "gdbm-open", 9, 9);
static SCM_DEFINE_SUBR(gdbm_gdbm_open__STUB, 1, 1, SCM_OBJ(&gdbm_gdbm_open__NAME), gdbm_gdbm_open, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_close(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_close(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  SCM_ENTER_SUBR("gdbm-close");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  {
CHECK_GDBM(gdbm);
if (gdbm->dbf) {
  gdbm_close(gdbm->dbf);
  gdbm->dbf = NULL;
}
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_close__NAME, "gdbm-close", 10, 10);
static SCM_DEFINE_SUBR(gdbm_gdbm_close__STUB, 1, 0, SCM_OBJ(&gdbm_gdbm_close__NAME), gdbm_gdbm_close, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_closedP(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_closedP(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  SCM_ENTER_SUBR("gdbm-closed?");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  {
{
int SCM_RESULT;
 SCM_RESULT = (gdbm->dbf == NULL);
SCM_RETURN(SCM_MAKE_BOOL(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_closedP__NAME, "gdbm-closed?", 12, 12);
static SCM_DEFINE_SUBR(gdbm_gdbm_closedP__STUB, 1, 0, SCM_OBJ(&gdbm_gdbm_closedP__NAME), gdbm_gdbm_closedP, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_store(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_store(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  ScmObj key_scm;
  ScmString* key;
  ScmObj val_scm;
  ScmString* val;
  ScmObj flags_scm;
  int flags;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("gdbm-store");
  if (Scm_Length(SCM_OPTARGS) > 1)
    Scm_Error("too many arguments: up to 4 is expected, %d given.", Scm_Length(SCM_OPTARGS)+3);
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  val_scm = SCM_ARGREF(2);
  if (!SCM_STRINGP(val_scm)) Scm_Error("string required, but got %S", val_scm);
  val = SCM_STRING(val_scm);
  if (SCM_NULLP(SCM_OPTARGS)) flags_scm = Scm_MakeInteger(0);
  else {
    flags_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  if (!SCM_INTP(flags_scm)) Scm_Error("small integer required, but got %S", flags_scm);
  flags = SCM_INT_VALUE(flags_scm);
  {
{
int SCM_RESULT;
datum dkey, dval;
CHECK_GDBM(gdbm);
TO_DATUM(dkey, key);
TO_DATUM(dval, val);
SCM_RESULT = gdbm_store(gdbm->dbf, dkey, dval, flags);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_store__NAME, "gdbm-store", 10, 10);
static SCM_DEFINE_SUBR(gdbm_gdbm_store__STUB, 3, 1, SCM_OBJ(&gdbm_gdbm_store__NAME), gdbm_gdbm_store, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_fetch(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_fetch(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("gdbm-fetch");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey, dval;
CHECK_GDBM(gdbm);
TO_DATUM(dkey, key);
dval = gdbm_fetch(gdbm->dbf, dkey);
FROM_DATUM(SCM_RESULT, dval);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_fetch__NAME, "gdbm-fetch", 10, 10);
static SCM_DEFINE_SUBR(gdbm_gdbm_fetch__STUB, 2, 0, SCM_OBJ(&gdbm_gdbm_fetch__NAME), gdbm_gdbm_fetch, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_delete(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_delete(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("gdbm-delete");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
int SCM_RESULT;
datum dkey;
CHECK_GDBM(gdbm);
TO_DATUM(dkey, key);
SCM_RESULT = gdbm_delete(gdbm->dbf, dkey);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_delete__NAME, "gdbm-delete", 11, 11);
static SCM_DEFINE_SUBR(gdbm_gdbm_delete__STUB, 2, 0, SCM_OBJ(&gdbm_gdbm_delete__NAME), gdbm_gdbm_delete, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_firstkey(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_firstkey(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  SCM_ENTER_SUBR("gdbm-firstkey");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey = gdbm_firstkey(gdbm->dbf);
FROM_DATUM(SCM_RESULT, dkey);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_firstkey__NAME, "gdbm-firstkey", 13, 13);
static SCM_DEFINE_SUBR(gdbm_gdbm_firstkey__STUB, 1, 0, SCM_OBJ(&gdbm_gdbm_firstkey__NAME), gdbm_gdbm_firstkey, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_nextkey(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_nextkey(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("gdbm-nextkey");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey, dnkey;
CHECK_GDBM(gdbm);
TO_DATUM(dkey, key);
dnkey = gdbm_nextkey(gdbm->dbf, dkey);
FROM_DATUM(SCM_RESULT, dnkey);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_nextkey__NAME, "gdbm-nextkey", 12, 12);
static SCM_DEFINE_SUBR(gdbm_gdbm_nextkey__STUB, 2, 0, SCM_OBJ(&gdbm_gdbm_nextkey__NAME), gdbm_gdbm_nextkey, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_reorganize(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_reorganize(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  SCM_ENTER_SUBR("gdbm-reorganize");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  {
{
int SCM_RESULT;
CHECK_GDBM(gdbm);
SCM_RESULT = gdbm_reorganize(gdbm->dbf);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_reorganize__NAME, "gdbm-reorganize", 15, 15);
static SCM_DEFINE_SUBR(gdbm_gdbm_reorganize__STUB, 1, 0, SCM_OBJ(&gdbm_gdbm_reorganize__NAME), gdbm_gdbm_reorganize, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_sync(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_sync(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  SCM_ENTER_SUBR("gdbm-sync");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  {
CHECK_GDBM(gdbm);
gdbm_sync(gdbm->dbf);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_sync__NAME, "gdbm-sync", 9, 9);
static SCM_DEFINE_SUBR(gdbm_gdbm_sync__STUB, 1, 0, SCM_OBJ(&gdbm_gdbm_sync__NAME), gdbm_gdbm_sync, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_existsP(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_existsP(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("gdbm-exists?");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
int SCM_RESULT;
datum dkey;
CHECK_GDBM(gdbm);
TO_DATUM(dkey, key);
SCM_RESULT = gdbm_exists(gdbm->dbf, dkey);
SCM_RETURN(SCM_MAKE_BOOL(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_existsP__NAME, "gdbm-exists?", 12, 12);
static SCM_DEFINE_SUBR(gdbm_gdbm_existsP__STUB, 2, 0, SCM_OBJ(&gdbm_gdbm_existsP__NAME), gdbm_gdbm_existsP, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_strerror(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_strerror(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj errno_scm;
  int errno;
  SCM_ENTER_SUBR("gdbm-strerror");
  errno_scm = SCM_ARGREF(0);
  if (!SCM_INTP(errno_scm)) Scm_Error("small integer required, but got %S", errno_scm);
  errno = SCM_INT_VALUE(errno_scm);
  {
{
ScmObj SCM_RESULT;
 SCM_RESULT = (SCM_MAKE_STR_IMMUTABLE(gdbm_strerror(errno)));
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_strerror__NAME, "gdbm-strerror", 13, 13);
static SCM_DEFINE_SUBR(gdbm_gdbm_strerror__STUB, 1, 0, SCM_OBJ(&gdbm_gdbm_strerror__NAME), gdbm_gdbm_strerror, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_setopt(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_setopt(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj gdbm_scm;
  ScmGdbm* gdbm;
  ScmObj option_scm;
  int option;
  ScmObj val_scm;
  ScmObj val;
  SCM_ENTER_SUBR("gdbm-setopt");
  gdbm_scm = SCM_ARGREF(0);
  if (!SCM_GDBMP(gdbm_scm)) Scm_Error("<gdbm> required, but got %S", gdbm_scm);
  gdbm = SCM_GDBM(gdbm_scm);
  option_scm = SCM_ARGREF(1);
  if (!SCM_INTP(option_scm)) Scm_Error("small integer required, but got %S", option_scm);
  option = SCM_INT_VALUE(option_scm);
  val_scm = SCM_ARGREF(2);
  val = (val_scm);
  {
{
int SCM_RESULT;
int ival;
CHECK_GDBM(gdbm);
if (SCM_EXACTP(val)) ival = Scm_GetUInteger(val);
else ival = !SCM_FALSEP(val);
SCM_RESULT = gdbm_setopt(gdbm->dbf, option, &ival, sizeof(int));
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_setopt__NAME, "gdbm-setopt", 11, 11);
static SCM_DEFINE_SUBR(gdbm_gdbm_setopt__STUB, 3, 0, SCM_OBJ(&gdbm_gdbm_setopt__NAME), gdbm_gdbm_setopt, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_version(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_version(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  SCM_ENTER_SUBR("gdbm-version");
  {
{
ScmObj SCM_RESULT;
 SCM_RESULT = (SCM_MAKE_STR_IMMUTABLE(gdbm_version));
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_version__NAME, "gdbm-version", 12, 12);
static SCM_DEFINE_SUBR(gdbm_gdbm_version__STUB, 0, 0, SCM_OBJ(&gdbm_gdbm_version__NAME), gdbm_gdbm_version, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj gdbm_gdbm_errno(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj gdbm_gdbm_errno(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  SCM_ENTER_SUBR("gdbm-errno");
  {
{
int SCM_RESULT;
SCM_RESULT = gdbm_errno;
gdbm_errno = 0;
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(gdbm_gdbm_errno__NAME, "gdbm-errno", 10, 10);
static SCM_DEFINE_SUBR(gdbm_gdbm_errno__STUB, 0, 0, SCM_OBJ(&gdbm_gdbm_errno__NAME), gdbm_gdbm_errno, NULL, NULL);

static SCM_DEFINE_STRING_CONST(gdbm_GDBM_READER__VAR__NAME, "GDBM_READER", 11, 11);
static ScmObj gdbm_GDBM_READER__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_WRITER__VAR__NAME, "GDBM_WRITER", 11, 11);
static ScmObj gdbm_GDBM_WRITER__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_WRCREAT__VAR__NAME, "GDBM_WRCREAT", 12, 12);
static ScmObj gdbm_GDBM_WRCREAT__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_NEWDB__VAR__NAME, "GDBM_NEWDB", 10, 10);
static ScmObj gdbm_GDBM_NEWDB__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_FAST__VAR__NAME, "GDBM_FAST", 9, 9);
static ScmObj gdbm_GDBM_FAST__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_SYNC__VAR__NAME, "GDBM_SYNC", 9, 9);
static ScmObj gdbm_GDBM_SYNC__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_NOLOCK__VAR__NAME, "GDBM_NOLOCK", 11, 11);
static ScmObj gdbm_GDBM_NOLOCK__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_INSERT__VAR__NAME, "GDBM_INSERT", 11, 11);
static ScmObj gdbm_GDBM_INSERT__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_REPLACE__VAR__NAME, "GDBM_REPLACE", 12, 12);
static ScmObj gdbm_GDBM_REPLACE__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_CACHESIZE__VAR__NAME, "GDBM_CACHESIZE", 14, 14);
static ScmObj gdbm_GDBM_CACHESIZE__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_FASTMODE__VAR__NAME, "GDBM_FASTMODE", 13, 13);
static ScmObj gdbm_GDBM_FASTMODE__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_SYNCMODE__VAR__NAME, "GDBM_SYNCMODE", 13, 13);
static ScmObj gdbm_GDBM_SYNCMODE__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_CENTFREE__VAR__NAME, "GDBM_CENTFREE", 13, 13);
static ScmObj gdbm_GDBM_CENTFREE__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(gdbm_GDBM_COALESCEBLKS__VAR__NAME, "GDBM_COALESCEBLKS", 17, 17);
static ScmObj gdbm_GDBM_COALESCEBLKS__VAR = SCM_UNBOUND;
void Scm_Init_gdbm(ScmModule *module)
{

  SCM_DEFINE(module, "gdbm-open", SCM_OBJ(&gdbm_gdbm_open__STUB));
  SCM_DEFINE(module, "gdbm-close", SCM_OBJ(&gdbm_gdbm_close__STUB));
  SCM_DEFINE(module, "gdbm-closed?", SCM_OBJ(&gdbm_gdbm_closedP__STUB));
  SCM_DEFINE(module, "gdbm-store", SCM_OBJ(&gdbm_gdbm_store__STUB));
  SCM_DEFINE(module, "gdbm-fetch", SCM_OBJ(&gdbm_gdbm_fetch__STUB));
  SCM_DEFINE(module, "gdbm-delete", SCM_OBJ(&gdbm_gdbm_delete__STUB));
  SCM_DEFINE(module, "gdbm-firstkey", SCM_OBJ(&gdbm_gdbm_firstkey__STUB));
  SCM_DEFINE(module, "gdbm-nextkey", SCM_OBJ(&gdbm_gdbm_nextkey__STUB));
  SCM_DEFINE(module, "gdbm-reorganize", SCM_OBJ(&gdbm_gdbm_reorganize__STUB));
  SCM_DEFINE(module, "gdbm-sync", SCM_OBJ(&gdbm_gdbm_sync__STUB));
  SCM_DEFINE(module, "gdbm-exists?", SCM_OBJ(&gdbm_gdbm_existsP__STUB));
  SCM_DEFINE(module, "gdbm-strerror", SCM_OBJ(&gdbm_gdbm_strerror__STUB));
  SCM_DEFINE(module, "gdbm-setopt", SCM_OBJ(&gdbm_gdbm_setopt__STUB));
  SCM_DEFINE(module, "gdbm-version", SCM_OBJ(&gdbm_gdbm_version__STUB));
  SCM_DEFINE(module, "gdbm-errno", SCM_OBJ(&gdbm_gdbm_errno__STUB));
  gdbm_GDBM_READER__VAR = Scm_Intern(&gdbm_GDBM_READER__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_READER__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_READER)));
  gdbm_GDBM_WRITER__VAR = Scm_Intern(&gdbm_GDBM_WRITER__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_WRITER__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_WRITER)));
  gdbm_GDBM_WRCREAT__VAR = Scm_Intern(&gdbm_GDBM_WRCREAT__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_WRCREAT__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_WRCREAT)));
  gdbm_GDBM_NEWDB__VAR = Scm_Intern(&gdbm_GDBM_NEWDB__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_NEWDB__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_NEWDB)));
  gdbm_GDBM_FAST__VAR = Scm_Intern(&gdbm_GDBM_FAST__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_FAST__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_FAST)));
  gdbm_GDBM_SYNC__VAR = Scm_Intern(&gdbm_GDBM_SYNC__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_SYNC__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_SYNC)));
  gdbm_GDBM_NOLOCK__VAR = Scm_Intern(&gdbm_GDBM_NOLOCK__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_NOLOCK__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_NOLOCK)));
  gdbm_GDBM_INSERT__VAR = Scm_Intern(&gdbm_GDBM_INSERT__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_INSERT__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_INSERT)));
  gdbm_GDBM_REPLACE__VAR = Scm_Intern(&gdbm_GDBM_REPLACE__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_REPLACE__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_REPLACE)));
  gdbm_GDBM_CACHESIZE__VAR = Scm_Intern(&gdbm_GDBM_CACHESIZE__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_CACHESIZE__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_CACHESIZE)));
  gdbm_GDBM_FASTMODE__VAR = Scm_Intern(&gdbm_GDBM_FASTMODE__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_FASTMODE__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_FASTMODE)));
  gdbm_GDBM_SYNCMODE__VAR = Scm_Intern(&gdbm_GDBM_SYNCMODE__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_SYNCMODE__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_SYNCMODE)));
  gdbm_GDBM_CENTFREE__VAR = Scm_Intern(&gdbm_GDBM_CENTFREE__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_CENTFREE__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_CENTFREE)));
  gdbm_GDBM_COALESCEBLKS__VAR = Scm_Intern(&gdbm_GDBM_COALESCEBLKS__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(gdbm_GDBM_COALESCEBLKS__VAR)), SCM_OBJ(Scm_MakeInteger(GDBM_COALESCEBLKS)));
}
