/* Generated by genstub.  Do not edit. */
#include <gauche.h>
#if defined(__CYGWIN__) || defined(__MINGW32__)
#define SCM_CGEN_CONST /*empty*/
#else
#define SCM_CGEN_CONST const
#endif

 #include <fcntl.h>
 #include <gauche/extend.h>
 #include "dbmconf.h"

 #if HAVE_NDBM_H
 #include <ndbm.h>
 #elif HAVE_GDBM_NDBM_H
 #include <gdbm/ndbm.h>
 #endif

 SCM_CLASS_DECL(Scm_NdbmClass); 
 static void ndbm_print(ScmObj, ScmPort *, ScmWriteContext*);
 SCM_DEFINE_BUILTIN_CLASS_SIMPLE(Scm_NdbmClass, ndbm_print);

 #define SCM_CLASS_NDBM       (&Scm_NdbmClass)
 #define SCM_NDBM(obj)        ((ScmNdbm*)obj)
 #define SCM_NDBMP(obj)       SCM_XTYPEP(obj, SCM_CLASS_NDBM)

 typedef struct ScmNdbmRec {
    SCM_HEADER;
    ScmObj name;
    DBM *dbf;                   /* NULL if closed */
 } ScmNdbm;

 static void ndbm_print(ScmObj obj, ScmPort *out, ScmWriteContext *ctx)
 {
    Scm_Printf(out, "#<ndbm-file %S>", SCM_NDBM(obj)->name);
 }

 #define TO_DATUM(datum_, scm_)                     \
   do {                                             \
     const ScmStringBody *b = SCM_STRING_BODY(scm_);\
     datum_.dptr = (char*)SCM_STRING_BODY_START(b); \
     datum_.dsize = SCM_STRING_BODY_SIZE(b);        \
   } while (0)
 #define FROM_DATUM(scm_, datum_)           \
   do {                                     \
     if (datum_.dptr) {                     \
       scm_ = Scm_MakeString(datum_.dptr, datum_.dsize, -1, SCM_STRING_COPYING); \
     } else {                               \
       scm_ = SCM_FALSE;                    \
     }                                      \
   } while (0)

 #define CHECK_NDBM(g)    if (!g->dbf) Scm_Error("ndbm file already closed: %S", g)

 /* Hack for initialization stub */
 static void Scm_ndbm_internal_init(ScmModule*);
 void Scm_Init_ndbm(void)
 {
    ScmModule *mod;
    SCM_INIT_EXTENSION(ndbm);
    mod = SCM_FIND_MODULE("dbm.ndbm", SCM_FIND_MODULE_CREATE);
    Scm_InitStaticClass(&Scm_NdbmClass, "<ndbm-file>", mod, NULL, 0);
    Scm_ndbm_internal_init(mod);
 }
 #define Scm_Init_ndbm  Scm_ndbm_internal_init

static void ndbm_finalize(ScmObj obj, void *data)
 {
    ScmNdbm *n = SCM_NDBM(obj);
    if (n->dbf) { dbm_close(n->dbf); n->dbf = NULL; }
 }

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_open(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_open(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj name_scm;
  ScmString* name;
  ScmObj flags_scm;
  int flags;
  ScmObj mode_scm;
  int mode;
  SCM_ENTER_SUBR("ndbm-open");
  name_scm = SCM_ARGREF(0);
  if (!SCM_STRINGP(name_scm)) Scm_Error("string required, but got %S", name_scm);
  name = SCM_STRING(name_scm);
  flags_scm = SCM_ARGREF(1);
  if (!SCM_INTP(flags_scm)) Scm_Error("small integer required, but got %S", flags_scm);
  flags = SCM_INT_VALUE(flags_scm);
  mode_scm = SCM_ARGREF(2);
  if (!SCM_INTP(mode_scm)) Scm_Error("small integer required, but got %S", mode_scm);
  mode = SCM_INT_VALUE(mode_scm);
  {
 ScmNdbm *z = SCM_NEW(ScmNdbm);
  SCM_SET_CLASS(z, SCM_CLASS_NDBM);
  Scm_RegisterFinalizer(SCM_OBJ(z), ndbm_finalize, NULL);
  z->name = SCM_OBJ(name);
  z->dbf = dbm_open(Scm_GetString(name), flags, mode);
  if (z->dbf == NULL) Scm_SysError("couldn't open ndbm file %S", name);
  SCM_RETURN(SCM_OBJ(z));
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_open__NAME, "ndbm-open", 9, 9);
static SCM_DEFINE_SUBR(ndbm_ndbm_open__STUB, 3, 0, SCM_OBJ(&ndbm_ndbm_open__NAME), ndbm_ndbm_open, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_close(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_close(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  SCM_ENTER_SUBR("ndbm-close");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  {
if (ndbm->dbf) {
  dbm_close(ndbm->dbf);
  ndbm->dbf = NULL;
}
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_close__NAME, "ndbm-close", 10, 10);
static SCM_DEFINE_SUBR(ndbm_ndbm_close__STUB, 1, 0, SCM_OBJ(&ndbm_ndbm_close__NAME), ndbm_ndbm_close, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_closedP(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_closedP(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  SCM_ENTER_SUBR("ndbm-closed?");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  {
{
int SCM_RESULT;
 SCM_RESULT = (ndbm->dbf == NULL);
SCM_RETURN(SCM_MAKE_BOOL(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_closedP__NAME, "ndbm-closed?", 12, 12);
static SCM_DEFINE_SUBR(ndbm_ndbm_closedP__STUB, 1, 0, SCM_OBJ(&ndbm_ndbm_closedP__NAME), ndbm_ndbm_closedP, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_store(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_store(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  ScmObj key_scm;
  ScmString* key;
  ScmObj val_scm;
  ScmString* val;
  ScmObj flags_scm;
  int flags;
  ScmObj SCM_OPTARGS = SCM_ARGREF(SCM_ARGCNT-1);
  SCM_ENTER_SUBR("ndbm-store");
  if (Scm_Length(SCM_OPTARGS) > 1)
    Scm_Error("too many arguments: up to 4 is expected, %d given.", Scm_Length(SCM_OPTARGS)+3);
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  val_scm = SCM_ARGREF(2);
  if (!SCM_STRINGP(val_scm)) Scm_Error("string required, but got %S", val_scm);
  val = SCM_STRING(val_scm);
  if (SCM_NULLP(SCM_OPTARGS)) flags_scm = Scm_MakeInteger(0);
  else {
    flags_scm = SCM_CAR(SCM_OPTARGS);
    SCM_OPTARGS = SCM_CDR(SCM_OPTARGS);
  }
  if (!SCM_INTP(flags_scm)) Scm_Error("small integer required, but got %S", flags_scm);
  flags = SCM_INT_VALUE(flags_scm);
  {
{
int SCM_RESULT;
datum dkey, dval;
CHECK_NDBM(ndbm);
TO_DATUM(dkey, key);
TO_DATUM(dval, val);
SCM_RESULT = dbm_store(ndbm->dbf, dkey, dval, flags);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_store__NAME, "ndbm-store", 10, 10);
static SCM_DEFINE_SUBR(ndbm_ndbm_store__STUB, 3, 1, SCM_OBJ(&ndbm_ndbm_store__NAME), ndbm_ndbm_store, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_fetch(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_fetch(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("ndbm-fetch");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey, dval;
CHECK_NDBM(ndbm);
TO_DATUM(dkey, key);
dval = dbm_fetch(ndbm->dbf, dkey);
FROM_DATUM(SCM_RESULT, dval);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_fetch__NAME, "ndbm-fetch", 10, 10);
static SCM_DEFINE_SUBR(ndbm_ndbm_fetch__STUB, 2, 0, SCM_OBJ(&ndbm_ndbm_fetch__NAME), ndbm_ndbm_fetch, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_existsP(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_existsP(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("ndbm-exists?");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
int SCM_RESULT;
datum dkey, dval;
CHECK_NDBM(ndbm);
TO_DATUM(dkey, key);
dval = dbm_fetch(ndbm->dbf, dkey);
SCM_RESULT = (dval.dptr != NULL);
SCM_RETURN(SCM_MAKE_BOOL(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_existsP__NAME, "ndbm-exists?", 12, 12);
static SCM_DEFINE_SUBR(ndbm_ndbm_existsP__STUB, 2, 0, SCM_OBJ(&ndbm_ndbm_existsP__NAME), ndbm_ndbm_existsP, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_delete(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_delete(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("ndbm-delete");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  key_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
int SCM_RESULT;
datum dkey;
CHECK_NDBM(ndbm);
TO_DATUM(dkey, key);
SCM_RESULT = dbm_delete(ndbm->dbf, dkey);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_delete__NAME, "ndbm-delete", 11, 11);
static SCM_DEFINE_SUBR(ndbm_ndbm_delete__STUB, 2, 0, SCM_OBJ(&ndbm_ndbm_delete__NAME), ndbm_ndbm_delete, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_firstkey(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_firstkey(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  SCM_ENTER_SUBR("ndbm-firstkey");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey;
CHECK_NDBM(ndbm);
dkey = dbm_firstkey(ndbm->dbf);
FROM_DATUM(SCM_RESULT, dkey);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_firstkey__NAME, "ndbm-firstkey", 13, 13);
static SCM_DEFINE_SUBR(ndbm_ndbm_firstkey__STUB, 1, 0, SCM_OBJ(&ndbm_ndbm_firstkey__NAME), ndbm_ndbm_firstkey, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_nextkey(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_nextkey(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  SCM_ENTER_SUBR("ndbm-nextkey");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey;
CHECK_NDBM(ndbm);
dkey = dbm_nextkey(ndbm->dbf);
FROM_DATUM(SCM_RESULT, dkey);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_nextkey__NAME, "ndbm-nextkey", 12, 12);
static SCM_DEFINE_SUBR(ndbm_ndbm_nextkey__STUB, 1, 0, SCM_OBJ(&ndbm_ndbm_nextkey__NAME), ndbm_ndbm_nextkey, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_error(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_error(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  SCM_ENTER_SUBR("ndbm-error");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  {
{
int SCM_RESULT;
CHECK_NDBM(ndbm);
SCM_RESULT = dbm_error(ndbm->dbf);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_error__NAME, "ndbm-error", 10, 10);
static SCM_DEFINE_SUBR(ndbm_ndbm_error__STUB, 1, 0, SCM_OBJ(&ndbm_ndbm_error__NAME), ndbm_ndbm_error, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj ndbm_ndbm_clearerror(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj ndbm_ndbm_clearerror(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj ndbm_scm;
  ScmNdbm* ndbm;
  SCM_ENTER_SUBR("ndbm-clearerror");
  ndbm_scm = SCM_ARGREF(0);
  if (!SCM_NDBMP(ndbm_scm)) Scm_Error("<ndbm> required, but got %S", ndbm_scm);
  ndbm = SCM_NDBM(ndbm_scm);
  {
CHECK_NDBM(ndbm);
dbm_clearerr(ndbm->dbf);
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(ndbm_ndbm_clearerror__NAME, "ndbm-clearerror", 15, 15);
static SCM_DEFINE_SUBR(ndbm_ndbm_clearerror__STUB, 1, 0, SCM_OBJ(&ndbm_ndbm_clearerror__NAME), ndbm_ndbm_clearerror, NULL, NULL);

static SCM_DEFINE_STRING_CONST(ndbm_DBM_INSERT__VAR__NAME, "DBM_INSERT", 10, 10);
static ScmObj ndbm_DBM_INSERT__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(ndbm_DBM_REPLACE__VAR__NAME, "DBM_REPLACE", 11, 11);
static ScmObj ndbm_DBM_REPLACE__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(ndbm_O_RDONLY__VAR__NAME, "O_RDONLY", 8, 8);
static ScmObj ndbm_O_RDONLY__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(ndbm_O_WRONLY__VAR__NAME, "O_WRONLY", 8, 8);
static ScmObj ndbm_O_WRONLY__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(ndbm_O_RDWR__VAR__NAME, "O_RDWR", 6, 6);
static ScmObj ndbm_O_RDWR__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(ndbm_O_CREAT__VAR__NAME, "O_CREAT", 7, 7);
static ScmObj ndbm_O_CREAT__VAR = SCM_UNBOUND;
static SCM_DEFINE_STRING_CONST(ndbm_O_TRUNC__VAR__NAME, "O_TRUNC", 7, 7);
static ScmObj ndbm_O_TRUNC__VAR = SCM_UNBOUND;
void Scm_Init_ndbm(ScmModule *module)
{

  SCM_DEFINE(module, "ndbm-open", SCM_OBJ(&ndbm_ndbm_open__STUB));
  SCM_DEFINE(module, "ndbm-close", SCM_OBJ(&ndbm_ndbm_close__STUB));
  SCM_DEFINE(module, "ndbm-closed?", SCM_OBJ(&ndbm_ndbm_closedP__STUB));
  SCM_DEFINE(module, "ndbm-store", SCM_OBJ(&ndbm_ndbm_store__STUB));
  SCM_DEFINE(module, "ndbm-fetch", SCM_OBJ(&ndbm_ndbm_fetch__STUB));
  SCM_DEFINE(module, "ndbm-exists?", SCM_OBJ(&ndbm_ndbm_existsP__STUB));
  SCM_DEFINE(module, "ndbm-delete", SCM_OBJ(&ndbm_ndbm_delete__STUB));
  SCM_DEFINE(module, "ndbm-firstkey", SCM_OBJ(&ndbm_ndbm_firstkey__STUB));
  SCM_DEFINE(module, "ndbm-nextkey", SCM_OBJ(&ndbm_ndbm_nextkey__STUB));
  SCM_DEFINE(module, "ndbm-error", SCM_OBJ(&ndbm_ndbm_error__STUB));
  SCM_DEFINE(module, "ndbm-clearerror", SCM_OBJ(&ndbm_ndbm_clearerror__STUB));
  ndbm_DBM_INSERT__VAR = Scm_Intern(&ndbm_DBM_INSERT__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(ndbm_DBM_INSERT__VAR)), SCM_OBJ(Scm_MakeInteger(DBM_INSERT)));
  ndbm_DBM_REPLACE__VAR = Scm_Intern(&ndbm_DBM_REPLACE__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(ndbm_DBM_REPLACE__VAR)), SCM_OBJ(Scm_MakeInteger(DBM_REPLACE)));
  ndbm_O_RDONLY__VAR = Scm_Intern(&ndbm_O_RDONLY__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(ndbm_O_RDONLY__VAR)), SCM_OBJ(Scm_MakeInteger(O_RDONLY)));
  ndbm_O_WRONLY__VAR = Scm_Intern(&ndbm_O_WRONLY__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(ndbm_O_WRONLY__VAR)), SCM_OBJ(Scm_MakeInteger(O_WRONLY)));
  ndbm_O_RDWR__VAR = Scm_Intern(&ndbm_O_RDWR__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(ndbm_O_RDWR__VAR)), SCM_OBJ(Scm_MakeInteger(O_RDWR)));
  ndbm_O_CREAT__VAR = Scm_Intern(&ndbm_O_CREAT__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(ndbm_O_CREAT__VAR)), SCM_OBJ(Scm_MakeInteger(O_CREAT)));
  ndbm_O_TRUNC__VAR = Scm_Intern(&ndbm_O_TRUNC__VAR__NAME);
  Scm_DefineConst(module, SCM_SYMBOL(SCM_OBJ(ndbm_O_TRUNC__VAR)), SCM_OBJ(Scm_MakeInteger(O_TRUNC)));
}
