/* Generated by genstub.  Do not edit. */
#include <gauche.h>
#if defined(__CYGWIN__) || defined(__MINGW32__)
#define SCM_CGEN_CONST /*empty*/
#else
#define SCM_CGEN_CONST const
#endif

 #include <gauche/extend.h>
 #include "dbmconf.h"

 #if HAVE_DBM_H
 #include <dbm.h>
 #elif HAVE_GDBM_DBM_H
 #include <gdbm/dbm.h>
 #endif

 #define CHECK_ODBM() if (!odbm_opened) Scm_Error("odbm file already closed")

 /* Hack for initialization stub */
 static void Scm_odbm_internal_init(ScmModule*);
 void Scm_Init_odbm(void)
 {
    SCM_INIT_EXTENSION(odbm);
    Scm_odbm_internal_init(SCM_FIND_MODULE("dbm.odbm", SCM_FIND_MODULE_CREATE));
 }
 #define Scm_Init_odbm  Scm_odbm_internal_init

 #define TO_DATUM(datum_, scm_)                    \
   do {                                            \
     const ScmStringBody *b = SCM_STRING_BODY(scm_);\
     datum_.dptr = (char*)SCM_STRING_BODY_START(b);\
     datum_.dsize = SCM_STRING_BODY_SIZE(b);       \
   } while (0)
 #define FROM_DATUM(scm_, datum_)           \
   do {                                     \
     if (datum_.dptr) {                     \
       scm_ = Scm_MakeString(datum_.dptr, datum_.dsize, -1, SCM_STRING_COPYING); \
     } else {                               \
       scm_ = SCM_FALSE;                    \
     }                                      \
   } while (0)

static int odbm_opened = FALSE;
#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_init(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_init(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj name_scm;
  ScmString* name;
  SCM_ENTER_SUBR("odbm-init");
  name_scm = SCM_ARGREF(0);
  if (!SCM_STRINGP(name_scm)) Scm_Error("string required, but got %S", name_scm);
  name = SCM_STRING(name_scm);
  {
{
int SCM_RESULT;
if (odbm_opened) Scm_Error("dbm file is already opened.");
SCM_RESULT = dbminit(Scm_GetString(name));
if (SCM_RESULT < 0) {
  Scm_SysError("couldn't open dbm database %S", name);
}
odbm_opened = TRUE;
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_init__NAME, "odbm-init", 9, 9);
static SCM_DEFINE_SUBR(odbm_odbm_init__STUB, 1, 0, SCM_OBJ(&odbm_odbm_init__NAME), odbm_odbm_init, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_close(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_close(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  SCM_ENTER_SUBR("odbm-close");
  {
if (odbm_opened) {
  dbmclose();
  odbm_opened = FALSE;
}
SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_close__NAME, "odbm-close", 10, 10);
static SCM_DEFINE_SUBR(odbm_odbm_close__STUB, 0, 0, SCM_OBJ(&odbm_odbm_close__NAME), odbm_odbm_close, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_closedP(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_closedP(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  SCM_ENTER_SUBR("odbm-closed?");
  {
{
int SCM_RESULT;
 SCM_RESULT = (!odbm_opened);
SCM_RETURN(SCM_MAKE_BOOL(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_closedP__NAME, "odbm-closed?", 12, 12);
static SCM_DEFINE_SUBR(odbm_odbm_closedP__STUB, 0, 0, SCM_OBJ(&odbm_odbm_closedP__NAME), odbm_odbm_closedP, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_store(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_store(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj key_scm;
  ScmString* key;
  ScmObj val_scm;
  ScmString* val;
  SCM_ENTER_SUBR("odbm-store");
  key_scm = SCM_ARGREF(0);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  val_scm = SCM_ARGREF(1);
  if (!SCM_STRINGP(val_scm)) Scm_Error("string required, but got %S", val_scm);
  val = SCM_STRING(val_scm);
  {
{
int SCM_RESULT;
datum dkey, dval;
CHECK_ODBM();
TO_DATUM(dkey, key);
TO_DATUM(dval, val);
SCM_RESULT = store(dkey, dval);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_store__NAME, "odbm-store", 10, 10);
static SCM_DEFINE_SUBR(odbm_odbm_store__STUB, 2, 0, SCM_OBJ(&odbm_odbm_store__NAME), odbm_odbm_store, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_fetch(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_fetch(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("odbm-fetch");
  key_scm = SCM_ARGREF(0);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey, dval;
CHECK_ODBM();
TO_DATUM(dkey, key);
dval = fetch(dkey);
FROM_DATUM(SCM_RESULT, dval);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_fetch__NAME, "odbm-fetch", 10, 10);
static SCM_DEFINE_SUBR(odbm_odbm_fetch__STUB, 1, 0, SCM_OBJ(&odbm_odbm_fetch__NAME), odbm_odbm_fetch, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_delete(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_delete(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("odbm-delete");
  key_scm = SCM_ARGREF(0);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
int SCM_RESULT;
datum dkey;
CHECK_ODBM();
TO_DATUM(dkey, key);
SCM_RESULT = delete(dkey);
SCM_RETURN(Scm_MakeInteger(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_delete__NAME, "odbm-delete", 11, 11);
static SCM_DEFINE_SUBR(odbm_odbm_delete__STUB, 1, 0, SCM_OBJ(&odbm_odbm_delete__NAME), odbm_odbm_delete, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_firstkey(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_firstkey(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  SCM_ENTER_SUBR("odbm-firstkey");
  {
{
ScmObj SCM_RESULT;
datum dkey;
CHECK_ODBM();
dkey = firstkey();
FROM_DATUM(SCM_RESULT, dkey);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_firstkey__NAME, "odbm-firstkey", 13, 13);
static SCM_DEFINE_SUBR(odbm_odbm_firstkey__STUB, 0, 0, SCM_OBJ(&odbm_odbm_firstkey__NAME), odbm_odbm_firstkey, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj odbm_odbm_nextkey(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj odbm_odbm_nextkey(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj key_scm;
  ScmString* key;
  SCM_ENTER_SUBR("odbm-nextkey");
  key_scm = SCM_ARGREF(0);
  if (!SCM_STRINGP(key_scm)) Scm_Error("string required, but got %S", key_scm);
  key = SCM_STRING(key_scm);
  {
{
ScmObj SCM_RESULT;
datum dkey, dnkey;
CHECK_ODBM();
TO_DATUM(dkey, key);
dnkey = nextkey(dkey);
FROM_DATUM(SCM_RESULT, dnkey);
SCM_RETURN(SCM_OBJ_SAFE(SCM_RESULT));
}
  }
}

static SCM_DEFINE_STRING_CONST(odbm_odbm_nextkey__NAME, "odbm-nextkey", 12, 12);
static SCM_DEFINE_SUBR(odbm_odbm_nextkey__STUB, 1, 0, SCM_OBJ(&odbm_odbm_nextkey__NAME), odbm_odbm_nextkey, NULL, NULL);

void Scm_Init_odbm(ScmModule *module)
{

  SCM_DEFINE(module, "odbm-init", SCM_OBJ(&odbm_odbm_init__STUB));
  SCM_DEFINE(module, "odbm-close", SCM_OBJ(&odbm_odbm_close__STUB));
  SCM_DEFINE(module, "odbm-closed?", SCM_OBJ(&odbm_odbm_closedP__STUB));
  SCM_DEFINE(module, "odbm-store", SCM_OBJ(&odbm_odbm_store__STUB));
  SCM_DEFINE(module, "odbm-fetch", SCM_OBJ(&odbm_odbm_fetch__STUB));
  SCM_DEFINE(module, "odbm-delete", SCM_OBJ(&odbm_odbm_delete__STUB));
  SCM_DEFINE(module, "odbm-firstkey", SCM_OBJ(&odbm_odbm_firstkey__STUB));
  SCM_DEFINE(module, "odbm-nextkey", SCM_OBJ(&odbm_odbm_nextkey__STUB));
}
