/* Generated by genstub.  Do not edit. */
#include <gauche.h>
#if defined(__CYGWIN__) || defined(__MINGW32__)
#define SCM_CGEN_CONST /*empty*/
#else
#define SCM_CGEN_CONST const
#endif

 #include <gauche/extend.h>
 #include <gauche/class.h>
 #include <gauche/uvector.h>
 #include "sha.h"

 typedef struct ScmSha1Rec {
   SCM_HEADER;
   SHA_CTX ctx;
 } ScmSha1;

 SCM_CLASS_DECL(Scm_Sha1Class);
 static ScmObj sha1_allocate(ScmClass *, ScmObj);
 SCM_DEFINE_BUILTIN_CLASS(Scm_Sha1Class,
                          NULL, NULL, NULL, sha1_allocate,
                          NULL);

 #define SCM_CLASS_SHA1      (&Scm_Sha1Class)
 #define SCM_SHA1(obj)       ((ScmSha1*)obj)
 #define SCM_SHA1P(obj)      SCM_XTYPEP(obj, SCM_CLASS_SHA1)

 static ScmObj sha1_allocate(ScmClass *klass, ScmObj initargs)
 {
   ScmSha1 *sha1 = SCM_ALLOCATE(ScmSha1, klass);
   SCM_SET_CLASS(sha1, klass);
   SHAInit(&sha1->ctx);
   return SCM_OBJ(sha1);
 }

 /* Hack for initialization stub */
 static void Scm_sha_internal_init(ScmModule*);
 void Scm_Init_sha1(void)
 {
   ScmModule *mod = SCM_FIND_MODULE("rfc.sha1", SCM_FIND_MODULE_CREATE);
   SCM_INIT_EXTENSION(sha1);
   Scm_InitStaticClass(&Scm_Sha1Class, "<sha1-context>", mod, NULL, 0);
   Scm_sha_internal_init(mod);
 }

 #define Scm_Init_sha1 Scm_sha_internal_init

#ifdef GAUCHE_SUBR_VM
static ScmObj sha1__25sha1_update(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj sha1__25sha1_update(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj sha1_scm;
  ScmSha1* sha1;
  ScmObj data_scm;
  ScmObj data;
  SCM_ENTER_SUBR("%sha1-update");
  sha1_scm = SCM_ARGREF(0);
  if (!SCM_SHA1P(sha1_scm)) Scm_Error("<sha1> required, but got %S", sha1_scm);
  sha1 = SCM_SHA1(sha1_scm);
  data_scm = SCM_ARGREF(1);
  data = (data_scm);
  {

  if (SCM_U8VECTORP(data)) {
    SHAUpdate(&sha1->ctx, (const unsigned char*)SCM_UVECTOR_ELEMENTS(SCM_U8VECTOR(data)), SCM_U8VECTOR_SIZE(SCM_U8VECTOR(data)));
  } else if (SCM_STRINGP(data)) {
    const ScmStringBody *b = SCM_STRING_BODY(data);
    SHAUpdate(&sha1->ctx, 
              (const unsigned char*)SCM_STRING_BODY_START(b), 
              SCM_STRING_BODY_SIZE(b));
  } else {
    Scm_Error("u8vector or string required, but got: %S", data);
  }
  SCM_RETURN(SCM_UNDEFINED);
  }
}

static SCM_DEFINE_STRING_CONST(sha1__25sha1_update__NAME, "%sha1-update", 12, 12);
static SCM_DEFINE_SUBR(sha1__25sha1_update__STUB, 2, 0, SCM_OBJ(&sha1__25sha1_update__NAME), sha1__25sha1_update, NULL, NULL);

#ifdef GAUCHE_SUBR_VM
static ScmObj sha1__25sha1_final(ScmVM *SCM_VMPTR, ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#else
static ScmObj sha1__25sha1_final(ScmObj *SCM_FP, int SCM_ARGCNT, void *data_)
#endif
{
  ScmObj sha1_scm;
  ScmSha1* sha1;
  SCM_ENTER_SUBR("%sha1-final");
  sha1_scm = SCM_ARGREF(0);
  if (!SCM_SHA1P(sha1_scm)) Scm_Error("<sha1> required, but got %S", sha1_scm);
  sha1 = SCM_SHA1(sha1_scm);
  {
  unsigned char digest[20];
  SHAFinal(digest, &sha1->ctx);
  SCM_RETURN(Scm_MakeString((const char*)digest, 20, 20, SCM_STRING_INCOMPLETE|SCM_STRING_COPYING));
  }
}

static SCM_DEFINE_STRING_CONST(sha1__25sha1_final__NAME, "%sha1-final", 11, 11);
static SCM_DEFINE_SUBR(sha1__25sha1_final__STUB, 1, 0, SCM_OBJ(&sha1__25sha1_final__NAME), sha1__25sha1_final, NULL, NULL);

void Scm_Init_sha1(ScmModule *module)
{

  SCM_DEFINE(module, "%sha1-update", SCM_OBJ(&sha1__25sha1_update__STUB));
  SCM_DEFINE(module, "%sha1-final", SCM_OBJ(&sha1__25sha1_final__STUB));
}
